#version 130
precision mediump float;

uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;
uniform mat4 TMVP_PositiveX;
uniform mat4 TMVP_NegativeX;
uniform mat4 TMVP_PositiveY;
uniform mat4 TMVP_NegativeY;
uniform mat4 TMVP_PositiveZ;
uniform mat4 TMVP_NegativeZ;
uniform float weight;

in vec4 vertex1;
in vec3 normal1;
in vec4 vertex2;
in vec3 normal2;
in vec2 texCoord;

out vec2 frag_texCoord;
out vec4 texCoordPositiveX;
out vec4 texCoordNegativeX;
out vec4 texCoordPositiveY;
out vec4 texCoordNegativeY;
out vec4 texCoordPositiveZ;
out vec4 texCoordNegativeZ;
out vec3 world_normal;
out vec4 world_position;

void main() {
	frag_texCoord = texCoord;
	
	//interpolation for frame-based animation
	vec4 vertex = mix(vertex1, vertex2, weight);
	vec3 normal = mix(normal1, normal2, weight);
	
	texCoordPositiveX = TMVP_PositiveX * vertex;
	texCoordNegativeX = TMVP_NegativeX * vertex;
	texCoordPositiveY = TMVP_PositiveY * vertex;
	texCoordNegativeY = TMVP_NegativeY * vertex;
	texCoordPositiveZ = TMVP_PositiveZ * vertex;
	texCoordNegativeZ = TMVP_NegativeZ * vertex;
	
	world_normal = (model * vec4(normal, 0.0)).xyz;    
	world_position = model * vertex;
    
	gl_Position = perspective * view * model * vertex;
}