#version 130
precision mediump float;

uniform vec4 fog_color;
uniform float fog_density;
uniform float transparency;
uniform sampler2D texture;

in vec2 frag_texCoord;

out vec4 fragColor;

void main() {
	float z = gl_FragCoord.z / gl_FragCoord.w;
	float fog_factor = exp2((-1.0) * pow((fog_density * z), 2.0));
	vec4 texColor = texture2D(texture, frag_texCoord);
	vec4 fogColor = vec4(fog_color.x, fog_color.y, fog_color.z, 0.0);
	
	if (texColor.w > 0.0) {
		fragColor = mix(fog_color, texColor, fog_factor);
		fragColor.w = texColor.w * transparency;
	}
	else {
		//fragColor.w = 0.0;
	}
}