#version 130
precision mediump float;

uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;
uniform mat4 TMVP_PositiveX;
uniform mat4 TMVP_NegativeX;
uniform mat4 TMVP_NegativeY;
uniform mat4 TMVP_PositiveZ;
uniform mat4 TMVP_NegativeZ;

in vec4 vertex;
in vec3 normal;
in vec2 texCoord;

out vec2 frag_texCoord;
out vec4 texCoordPositiveX;
out vec4 texCoordNegativeX;
out vec4 texCoordNegativeY;
out vec4 texCoordPositiveZ;
out vec4 texCoordNegativeZ;
out vec3 world_normal;
out vec4 world_position;

void main() {
	frag_texCoord = texCoord;
	
	texCoordPositiveX = TMVP_PositiveX * vertex;
	texCoordNegativeX = TMVP_NegativeX * vertex;
	texCoordNegativeY = TMVP_NegativeY * vertex;
	texCoordPositiveZ = TMVP_PositiveZ * vertex;
	texCoordNegativeZ = TMVP_NegativeZ * vertex;
	
	world_normal = (model * vec4(normal, 0.0f)).xyz;
	world_normal = normalize(world_normal);
	world_position = model * vertex;
    
	gl_Position = perspective * view * model * vertex;
}