#version 130
precision mediump float;

uniform mat4 perspective;
uniform mat4 cameraview;
uniform vec3 position;

in vec4 vertex;
in vec2 texCoord;

out vec2 frag_texCoord;

void main() {
	frag_texCoord = texCoord;
						  
	mat4 modelview = mat4(1.0, 0.0, 0.0, 0.0,
						  0.0, 1.0, 0.0, 0.0,
						  0.0, 0.0, 1.0, 0.0,
						  position.x, position.y, position.z, 1.0);
						  
	modelview = cameraview * modelview;
	
	modelview[0][0] = 1.0f;
	modelview[2][0] = 0.0f;
	modelview[0][1] = 0.0f;
	modelview[1][1] = 1.0f;
	modelview[2][1] = 0.0f;
	modelview[0][2] = 0.0f;
	modelview[1][2] = 0.0f;
	modelview[2][2] = 1.0f;
    
	gl_Position = perspective * modelview * vertex;
}