#version 130
precision mediump float;

uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;

in vec4 vertex;
in vec3 normal;
in vec2 texCoord;

out vec2 frag_texCoord;
out vec3 world_normal;
out vec4 world_position;

void main() {
	frag_texCoord = texCoord;
	
	world_normal = (model * vec4(normal, 0.0f)).xyz;    
	world_position = model * vertex;
    
	gl_Position = perspective * view * model * vertex;
}